#include "global.h"
#include "rs232.h"

inline void 
rs232_init() {
  UBRR = UC_CLOCK /16 /BAUDRATE -1;  /* set baudrate register */
  UCR |= _BV(TXEN) | _BV(RXEN) | _BV(RXCIE);  /* enable sending and receiving */
}

void
rs232_sendbyte(uint8_t data) {
  while (! (USR & _BV(UDRE)))   /* wait till UART data register empty */
    ;
  UDR = data;
}

void
rs232_sendhex(uint8_t data) {
  while (!(USR & _BV(UDRE)))
    ;
  if (data < 0xA0)
    UDR = (data / 16) + '0';
  else
    UDR = (data / 16) + 'A' - 10;

  while (!(USR & _BV(UDRE)))
    ;

  data &= 0x0f;
  data += '0';
  if (data > '9')
    data += 'A' - '0'- 10;
  UDR = data;
}

